// SPDX-License-Identifier: Apache-2.0
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { FullRedeemAtMaturityCommand, FullRedeemAtMaturityCommandResponse } from "./FullRedeemAtMaturityCommand";
import { FullRedeemAtMaturityCommandError } from "./error/FullRedeemAtMaturityCommandError";
import { CommandHandler } from "../../../../../core/decorator/CommandHandlerDecorator";
import { lazyInject } from "../../../../../core/decorator/LazyInjectDecorator";
import TransactionService from "../../../../service/transaction/TransactionService";
import AccountService from "../../../../service/account/AccountService";
import ContractService from "../../../../service/contract/ContractService";
import SecurityService from "../../../../service/security/SecurityService";
import ValidationService from "../../../../service/validation/ValidationService";
let FullRedeemAtMaturityCommandHandler = class FullRedeemAtMaturityCommandHandler {
    securityService;
    accountService;
    transactionService;
    validationService;
    contractService;
    constructor(securityService, accountService, transactionService, validationService, contractService) {
        this.securityService = securityService;
        this.accountService = accountService;
        this.transactionService = transactionService;
        this.validationService = validationService;
        this.contractService = contractService;
    }
    async execute(command) {
        try {
            const { securityId, sourceId } = command;
            const handler = this.transactionService.getHandler();
            const securityEvmAddress = await this.contractService.getContractEvmAddress(securityId);
            const sourceEvmAddress = await this.accountService.getAccountEvmAddress(sourceId);
            const res = await handler.fullRedeemAtMaturity(securityEvmAddress, sourceEvmAddress, securityId);
            return Promise.resolve(new FullRedeemAtMaturityCommandResponse(res.error === undefined, res.id));
        }
        catch (error) {
            throw new FullRedeemAtMaturityCommandError(error);
        }
    }
};
FullRedeemAtMaturityCommandHandler = __decorate([
    CommandHandler(FullRedeemAtMaturityCommand),
    __param(0, lazyInject(SecurityService)),
    __param(1, lazyInject(AccountService)),
    __param(2, lazyInject(TransactionService)),
    __param(3, lazyInject(ValidationService)),
    __param(4, lazyInject(ContractService)),
    __metadata("design:paramtypes", [SecurityService,
        AccountService,
        TransactionService,
        ValidationService,
        ContractService])
], FullRedeemAtMaturityCommandHandler);
export { FullRedeemAtMaturityCommandHandler };
